HDU 4283-You Are the One(区间DP)

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=4283

You Are the One

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4238    Accepted Submission(s): 1977


Problem Description
  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?
 

Input
  The first line contains a single integer T, the number of test cases.  For each case, the first line is n (0 < n <= 100)
  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)
 

Output
  For each test case, output the least summary of unhappiness .
 

Sample Input
  
   
   
2    5 1 2 3 4 5 5 5 4 3 2 2
 

Sample Output
  
   
   
Case #1: 20 Case #2: 24
 

题意:有n个人排成一排要上台表演,每个人有一个屌丝值di。第k个上台表演的人,他的不满意度为(k-1)*di。

现在有一个类似于栈的黑屋子,你可以让某些人进入这个黑屋子。这些人要按照排的顺序来,那么对于排在最前面的人,

就有两个选择:

(1)让他直接上台表演;

(2)让他暂时进黑屋子。

现在请你选择一个合理的调度顺序,使得最后的总不满意度最小?



/* 
dp[i][j]表示从第i个人到第j个人这段区间的最小花费(是只考虑这j-i+1个人,不需要考虑前面有多少人) 
那么对于dp[i][j]的第i个人,就有可能第1个上场,也可以第j-i+1个上场。考虑第K个上场 
即在i+1之后的K-1个人是率先上场的,那么就出现了一个子问题 dp[i+1][i+k-1]表示在第i个人之前上场的 
对于第i个人,由于是第k个上场的,那么屌丝值便是a[i]*(k-1) 
其余的人是排在第k+1个之后出场的,也就是一个子问题dp[i+k][j],对于这个区间的人,由于排在第k+1个之后,所以整体愤怒值要加上k*(sum[j]-sum[i+k-1]) 
*/ 
#include <stdio.h>
#include <string.h>
#include <algorithm>
#define maxn 105
#define inf 0x3f3f3f3f
using namespace std;

int a[maxn];
int sum[maxn];
int dp[maxn][maxn];
int main()
{
	int T, k=1;
	scanf("%d", &T);
	while(T--)
	{
		memset(sum, 0, sizeof(sum));
		int n;
		scanf("%d", &n);
		for(int i=1; i<=n; i++)
			{
				scanf("%d", &a[i]);
				sum[i] = sum[i-1]+a[i];
			}
		memset(dp,0,sizeof(dp));
        for(int i = 1; i<=n; i++)
        {
            for(int j = i+1; j<=n; j++)
                dp[i][j] = inf;
        }
		for(int len=2; len<=n; len++)
			for(int i=1; i+len-1<=n; i++)
			{
				int j = i+len-1;
				for(int k=1; k<=j-i+1; k++)
				{
					dp[i][j] = min(dp[i][j], dp[i+1][i+k-1]+dp[i+k][j] + k*(sum[j]-sum[i+k-1])+a[i]*(k-1));
				}
			}
		printf("Case #%d: %d\n", k++, dp[1][n]);
	}
	return 0;
}


猜你喜欢

转载自blog.csdn.net/qq_31281327/article/details/76582995